﻿/* =========================================================================

InDesign ExtendScript

NAME: InWash
VERSION: 1.7

AUTHOR: Vitaly Batushev
DATE  : 2.10.2005

DESCRIPTION: Скрипт удаляет из публикации по выбору пользователя
все неиспользуемые цвета, символьные и абзацные стили, пустые (в том числе
содержащие только символ абзаца, табуляции или пробела) текстовые фреймы,
а также разрывает связи с текстовыми файлами.

Для Adobe InDesign CS/CS2

SUPPORT: http://indesign.rudtp.ru
E-MAIL: vbatushev@indesign.rudtp.ru

============================================================================ */

var ScriptName = getFileNameOnly(app.activeScript.name);

//=== Start of Language Settings ====================================================	
try {
	if (app.version.substr(0,1) > 3 ) {
		$.locale = null;
		$.localize = true;
		var strUnusedSwatches = localize({en: 'Delete Unused Swatches', ru: 'Удалить неиспользуемые цвета'});
		var strUnusedCharStyles = localize({en: 'Delete Unused Character Styles', ru: 'Удалить неиспользуемые символьные стили'});
		var strUnusedParaStyles = localize({en: 'Delete Unused Paragraph Styles', ru: 'Удалить неиспользуемые абзацные стили'});
		var strBreakTextLinks = localize({en: 'Break Text Links', ru: 'Разорвать связи с текстовыми материалами'});
		var strDelEmptyFrames = localize({en: 'Delete Empty Text Frames', ru: 'Удалить пустые текстовые фреймы'});
		var strColorFrame = localize({en: 'Not Remove Colored Text Frames', ru: 'Не удалять окрашенные текстовые фреймы'});;
		var strLockedFrame = localize({en: 'Not Remove Locked Frames', ru:'Не удалять закрепленные фреймы'});
		var strParaStylesCount = localize({en: 'paragraph styles are removed.', ru:'стилей абзацев было удалено.'});
		var strCharStylesCount = localize({en: 'character styles are removed.', ru:'символьных стилей было удалено.'});
		var strColorsCount = localize({en: 'colors are removed.', ru:'цветов было удалено.'});	
		var strLinks = localize({en: 'Links with', ru:'Связи с'});
		var strBrokenOff = localize({en: 'TextFrames are broken off.', ru:'текстовыми фреймами были разорваны.'});
		var strEmptyFrameCount = localize({en: 'empty TextFrames are removed.', ru:'пустых текстовых было удалено.'});
		var strComplete = localize({en: 'Complete!', ru: 'Готово!'});
	} else {
		var strUnusedSwatches = 'Delete Unused Swatches';
		var strUnusedCharStyles = 'Delete Unused Character Styles';
		var strUnusedParaStyles = 'Delete Unused Paragraph Styles';
		var strBreakTextLinks = 'Break Text Links';
		var strDelEmptyFrames = "Delete Empty Text Frames";
		var strColorFrame = "Not Remove Colored Text Frames";
		var strLockedFrame = "Not Remove Locked Frames";
		var strParaStylesCount = "paragraph styles are removed.";
		var strCharStylesCount = "character styles are removed.";
		var strColorsCount = "colors are removed.";		
		var strLinks = "Links with";
		var strBrokenOff = "TextFrames are broken off.";
		var strEmptyFrameCount = "empty TextFrames are removed."
		var strComplete = 'Complete!';		
	}
} catch (e) {
		var strUnusedSwatches = 'Delete Unused Swatches';
		var strUnusedCharStyles = 'Delete Unused Character Styles';
		var strUnusedParaStyles = 'Delete Unused Paragraph Styles';
		var strBreakTextLinks = 'Break Text Links';
		var strDelEmptyFrames = "Delete Empty Text Frames";
		var strColorFrame = "Not Remove Colored Text Frames";
		var strLockedFrame = "Not Remove Locked Frames";
		var strParaStylesCount = "paragraph styles are removed.";
		var strCharStylesCount = "character styles are removed.";
		var strColorsCount = "colors are removed.";		
		var strLinks = "Links with";
		var strBrokenOff = "TextFrames are broken off.";
		var strEmptyFrameCount = "empty TextFrames are removed."
		var strComplete = 'Complete!';		
}					
//=== End of Language Settings ====================================================	

	var myIniFile = new File (app.activeScript.path + "/" + ScriptName + ".ini");
	if (!myIniFile.exists) {
		crtini = CreateINI(ScriptName);
		eval ("//@include \'" + ScriptName + ".ini\';");
	} else {
		eval ("//@include \'" + ScriptName + ".ini\';");
	}

with (app) {
	if (documents.length > 0)
	{
	   	var myDialog = dialogs.add({name:ScriptName + " v." + iniScriptVersion});
	   	with (myDialog) {
   			with (dialogColumns.add()){
   				with (dialogRows.add()){
   				with (dialogColumns.add()){
   					with (borderPanels.add()) {
	   					with (dialogColumns.add()){
   							var RemCharStyles = checkboxControls.add({checkedState:iniUCS, staticLabel:strUnusedCharStyles});
   							var RemParaStyles = checkboxControls.add({checkedState:iniUPS, staticLabel:strUnusedParaStyles});
   							var RemColors = checkboxControls.add({checkedState:iniUSw, staticLabel:strUnusedSwatches});
   						}
   					}
   				}
   				}
   				with (dialogRows.add()){
   				with (dialogColumns.add()){
   					with (borderPanels.add()) {
	   					with (dialogColumns.add()){
   							var RemEmptyFrames = checkboxControls.add({checkedState:iniEmptyFrame, staticLabel:strDelEmptyFrames});
   							var ColoredFrames = checkboxControls.add({checkedState:iniColFrame, staticLabel:strColorFrame});
   							var LockedFrames = checkboxControls.add({checkedState:iniLockFrame, staticLabel:strLockedFrame});
   						}
   					}
   				}
   				}
   				with (dialogRows.add()){
   				var breakLinks = checkboxControls.add({checkedState:iniBreak, staticLabel:strBreakTextLinks});
   				}
   			}
   		}
   		var myDoc = activeDocument;
		var result = myDialog.show();
		if (result == false) { exit();}
		if(RemParaStyles.checkedState == true) { var DPS = DelStyles(myDoc, 'Paras'); } else { var DPS = ""; }
		if(RemCharStyles.checkedState == true) { var DCS = DelStyles(myDoc, 'Chars'); } else { var DCS = ""; }
		if(RemColors.checkedState == true) { var DC = DelColors(myDoc); } else { var DC = ""; }
		if(RemEmptyFrames.checkedState == true) { var DEF = DeleteEmptyFrames(ColoredFrames.checkedState, LockedFrames.checkedState); } else { var DEF = ""; }
		if(breakLinks.checkedState == true) { var BS = BreakStories(myDoc); } else { var BS = ""; }		
		SaveINI(ScriptName, RemParaStyles.checkedState, RemCharStyles.checkedState, RemColors.checkedState, RemEmptyFrames.checkedState, ColoredFrames.checkedState, LockedFrames.checkedState, breakLinks.checkedState);
		myDialog.destroy();
		var myText = DPS + DCS + DC + DEF + BS + strComplete;
		alert(myText);
		exit();	
	}
}

function DelStyles(myDoc, StyleType) {
	if (StyleType == 'Chars') {
		var myStyles = myDoc.characterStyles;
		var stringInfo = strCharStylesCount;
	} else {
		var myStyles = myDoc.paragraphStyles;
		var stringInfo = strParaStylesCount;
	}
	if (myStyles.length > 1) {
		var i = 1;
		var DelPScount = 0;
		do 	{
			var myStyle = myStyles[i];
			app.findPreferences = null;
			app.changePreferences = null;
			if (StyleType == 'Chars') {
				app.findPreferences.appliedCharacterStyle = myStyles[i];
			} else {
				app.findPreferences.appliedParagraphStyle = myStyles[i];
			}
			var searchResult = myDoc.search();
			if (searchResult == 0) {
				try { myStyle.remove(); DelPScount++; } catch(e) { i++; }
			} else { i++; }
		} while (i < myStyles.length); 
	}
	app.findPreferences = null;
	app.changePreferences = null;
	return DelStyles = DelPScount + " " + stringInfo + "\n";
} 

function DelColors (myDoc) {
	var DelColorCount = 0;
	if (myDoc.unusedSwatches.length > 0) {
		for (i = myDoc.unusedSwatches.length - 1; i > -1; i--) {
			myDoc.unusedSwatches[i].remove(); DelColorCount++;
		}
	}
	return DelColors = DelColorCount + " " + strColorsCount + "\n";
}

function BreakStories (myDoc) {
	var BreakStoryCount = 0;
	for (i = myDoc.links.length - 1; i > -1; i--) {
		if (myDoc.links[i].parent.constructor.name == 'Story') {
			myDoc.links[i].unlink(); BreakStoryCount++;
		}
	}
	return BreakStories = strLinks + " " + BreakStoryCount + " " + strBrokenOff + "\n";
} 

function DeleteEmptyFrames ( isColored, isLocked) {
	var myDoc = app.activeDocument;
	var uDEF =  new Array();
	var allFrames = myDoc.textFrames.length;
	var TFcount = 0;
	for (i = myDoc.textFrames.length - 1; i > -1; i--) {
		switch (myDoc.textFrames[i].contents) {
			case "":
			case " ":
			case "\t":
			case "\r":
				if(isColored == true) {
					switch (myDoc.textFrames[i].fillColor.name) {
						case "None":
						case "Paper":
			   				if(isLocked == true) {
			   					if(myDoc.textFrames[i].locked == false) {
									myDoc.textFrames[i].remove();
									TFcount++;
								}
							} else {
								myDoc.textFrames[i].locked = false;	
								myDoc.textFrames[i].remove();
								TFcount++;
							}
						break;
					}
				} else {
			   		if(isLocked == true) {
			   			if(myDoc.textFrames[i].locked == false) {
							myDoc.textFrames[i].remove();
							TFcount++;
						}
					} else {
						myDoc.textFrames[i].locked = false;	
						myDoc.textFrames[i].remove();
						TFcount++;
					}
				}
			    break;
		}
		
	}
	myDoc = null;
	return DelEmptyFrames = TFcount + " " + strEmptyFrameCount + "\n";
}

function CreateINI(nScriptName) {	
	var myNewINIfile = new File (app.activeScript.path + "/" + nScriptName + ".ini");
	myNewINIfile.open("w");
	var myINI = "var iniScriptName = \"" + nScriptName + "\";\n";
	myINI = myINI + "var iniScriptVersion = \"1.7\";\n";
	myINI = myINI + "var iniLangFile = \"" + nScriptName + ".ru.slang\";\n";
	myINI = myINI + "var iniUCS = true;\n";
	myINI = myINI + "var iniUPS = true;\n";
	myINI = myINI + "var iniUSw = true;\n";
	myINI = myINI + "var iniEmptyFrame = true;\n";
	myINI = myINI + "var iniColFrame = true;\n";
	myINI = myINI + "var iniLockFrame = false;\n";
	myINI = myINI + "var iniBreak = false;\n";
	myNewINIfile.write(myINI);
	myNewINIfile.close();	
	myINI = undefined;
	return CreateINI;
}
function SaveINI(nScriptName, valUCS, valUPS, valUSw, valEmptyFrame, valColFrame, valLockFrame, valBreak) {	
	var mySaveINIfile = new File (app.activeScript.path + "/" + nScriptName + ".ini");
	mySaveINIfile.open("w");
	var myINI = "var iniScriptName = \"" + nScriptName + "\";\n";
	myINI = myINI + "var iniScriptVersion = \"1.7\";\n";
	myINI = myINI + "var iniLangFile = \"" + iniLangFile + "\";\n";
	myINI = myINI + "var iniUCS = " + valUCS + ";\n";
	myINI = myINI + "var iniUPS = " + valUPS + ";\n";
	myINI = myINI + "var iniUSw = " + valUSw + ";\n";
	myINI = myINI + "var iniEmptyFrame = " + valEmptyFrame + ";\n";
	myINI = myINI + "var iniColFrame = " + valColFrame + ";\n";
	myINI = myINI + "var iniLockFrame = " + valLockFrame + ";\n";
	myINI = myINI + "var iniBreak = " + valBreak + ";\n";
	mySaveINIfile.write(myINI);
	mySaveINIfile.close();
	myINI = undefined;
	return SaveINI;
}
function getFileNameOnly (myFileName) {
	var myString = "";
	var myResult = myFileName.lastIndexOf(".");
	if (myResult == -1) { myString = myFileName; }
	else { myString = myFileName.substr(0, myResult); }
	return myString;
}